# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 0.1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacetower_orbit_determination_python_client.models.field_description import FieldDescription
from spacetower_orbit_determination_python_client.models.frame_identifier import FrameIdentifier
from spacetower_orbit_determination_python_client.models.input_measurements import InputMeasurements
from spacetower_orbit_determination_python_client.models.measurement_type import MeasurementType
from typing import Optional, Set
from typing_extensions import Self

class PositionInputMeasurements(InputMeasurements):
    """
    Dated-weighted position measurement series with field descriptions in a specified frame. Each set of measurement data contains the following ordered content: x-position, y-position, z-position and measurement weight 
    """ # noqa: E501
    frame: FrameIdentifier
    standard_deviations: Optional[List[Union[StrictFloat, StrictInt]]] = Field(default=None, description="Standard deviations for the entire set of measurements. The data contains a standard deviation for each of the following ordered content: position (applied to all directions) ", alias="standardDeviations")
    data: List[List[Union[StrictFloat, StrictInt]]] = Field(description="[[pos-x[m], pos-y[m], pos-z[m], weight[-] (default: 1)], ...]")
    __properties: ClassVar[List[str]] = ["dates", "description", "measurementType", "frame", "standardDeviations", "data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PositionInputMeasurements from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in description (list)
        _items = []
        if self.description:
            for _item in self.description:
                if _item:
                    _items.append(_item.to_dict())
            _dict['description'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PositionInputMeasurements from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dates": obj.get("dates"),
            "description": [FieldDescription.from_dict(_item) for _item in obj["description"]] if obj.get("description") is not None else None,
            "measurementType": obj.get("measurementType"),
            "frame": obj.get("frame"),
            "standardDeviations": obj.get("standardDeviations"),
            "data": obj.get("data")
        })
        return _obj


